Index: /trunk/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncTop.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncTop.cpp	(revision 1413)
@@ -1164,49 +1290,49 @@
     }
   }
-  m_cPPS.setSliceChromaQpFlag(bChromaDeltaQPEnabled);
-#endif
-
-  m_cPPS.setEntropyCodingSyncEnabledFlag( m_entropyCodingSyncEnabledFlag );
-  m_cPPS.setTilesEnabledFlag( (m_iNumColumnsMinus1 > 0 || m_iNumRowsMinus1 > 0) );
-  m_cPPS.setUseWP( m_useWeightedPred );
-  m_cPPS.setWPBiPred( m_useWeightedBiPred );
-  m_cPPS.setOutputFlagPresentFlag( false );
-#if NH_MV
-  m_cPPS.setNumExtraSliceHeaderBits( 2 ); 
-#endif
-  m_cPPS.setSignHideFlag(getSignHideFlag());
+  pps.setSliceChromaQpFlag(bChromaDeltaQPEnabled);
+
+  pps.setEntropyCodingSyncEnabledFlag( m_entropyCodingSyncEnabledFlag );
+  pps.setTilesEnabledFlag( (m_iNumColumnsMinus1 > 0 || m_iNumRowsMinus1 > 0) );
+  pps.setUseWP( m_useWeightedPred );
+  pps.setWPBiPred( m_useWeightedBiPred );
+  pps.setOutputFlagPresentFlag( false );
+#if NH_MV
+  pps.setNumExtraSliceHeaderBits( 2 ); 
+#endif
+  pps.setSignDataHidingEnabledFlag(getSignDataHidingEnabledFlag());
+
   if ( getDeblockingFilterMetric() )
   {
-    m_cPPS.setDeblockingFilterOverrideEnabledFlag(true);
-    m_cPPS.setPicDisableDeblockingFilterFlag(false);
+    pps.setDeblockingFilterOverrideEnabledFlag(true);
+    pps.setPPSDeblockingFilterDisabledFlag(false);
   }
   else
   {
-      m_cPPS.setDeblockingFilterOverrideEnabledFlag( !getLoopFilterOffsetInPPS() );
-      m_cPPS.setPicDisableDeblockingFilterFlag( getLoopFilterDisable() );
-    }
-
-  if (! m_cPPS.getPicDisableDeblockingFilterFlag())
-  {
-    m_cPPS.setDeblockingFilterBetaOffsetDiv2( getLoopFilterBetaOffset() );
-    m_cPPS.setDeblockingFilterTcOffsetDiv2( getLoopFilterTcOffset() );
+    pps.setDeblockingFilterOverrideEnabledFlag( !getLoopFilterOffsetInPPS() );
+    pps.setPPSDeblockingFilterDisabledFlag( getLoopFilterDisable() );
+    }
+
+  if (! pps.getPPSDeblockingFilterDisabledFlag())
+  {
+    pps.setDeblockingFilterBetaOffsetDiv2( getLoopFilterBetaOffset() );
+    pps.setDeblockingFilterTcOffsetDiv2( getLoopFilterTcOffset() );
   }
   else
   {
-    m_cPPS.setDeblockingFilterBetaOffsetDiv2(0);
-    m_cPPS.setDeblockingFilterTcOffsetDiv2(0);
+    pps.setDeblockingFilterBetaOffsetDiv2(0);
+    pps.setDeblockingFilterTcOffsetDiv2(0);
   }
 
   // deblockingFilterControlPresentFlag is true if any of the settings differ from the inferred values:
-  const Bool deblockingFilterControlPresentFlag = m_cPPS.getDeblockingFilterOverrideEnabledFlag() ||
-                                                  m_cPPS.getPicDisableDeblockingFilterFlag()      ||
-                                                  m_cPPS.getDeblockingFilterBetaOffsetDiv2() != 0 ||
-                                                  m_cPPS.getDeblockingFilterTcOffsetDiv2() != 0;
-
-  m_cPPS.setDeblockingFilterControlPresentFlag(deblockingFilterControlPresentFlag);
-
-  m_cPPS.setLog2ParallelMergeLevelMinus2   (m_log2ParallelMergeLevelMinus2 );
-  m_cPPS.setCabacInitPresentFlag(CABAC_INIT_PRESENT_FLAG);
-  m_cPPS.setLoopFilterAcrossSlicesEnabledFlag( m_bLFCrossSliceBoundaryFlag );
+  const Bool deblockingFilterControlPresentFlag = pps.getDeblockingFilterOverrideEnabledFlag() ||
+                                                  pps.getPPSDeblockingFilterDisabledFlag()     ||
+                                                  pps.getDeblockingFilterBetaOffsetDiv2() != 0 ||
+                                                  pps.getDeblockingFilterTcOffsetDiv2() != 0;
+
+  pps.setDeblockingFilterControlPresentFlag(deblockingFilterControlPresentFlag);
+
+  pps.setLog2ParallelMergeLevelMinus2   (m_log2ParallelMergeLevelMinus2 );
+  pps.setCabacInitPresentFlag(CABAC_INIT_PRESENT_FLAG);
+  pps.setLoopFilterAcrossSlicesEnabledFlag( m_bLFCrossSliceBoundaryFlag );
 
 
@@ -1233,27 +1359,29 @@
   }
   assert(bestPos <= 15);
-  m_cPPS.setNumRefIdxL0DefaultActive(bestPos);
-  m_cPPS.setNumRefIdxL1DefaultActive(bestPos);
-  m_cPPS.setTransquantBypassEnableFlag(getTransquantBypassEnableFlag());
-  m_cPPS.setUseTransformSkip( m_useTransformSkip );
-  m_cPPS.getPpsRangeExtension().setLog2MaxTransformSkipBlockSize( m_log2MaxTransformSkipBlockSize  );
+  pps.setNumRefIdxL0DefaultActive(bestPos);
+  pps.setNumRefIdxL1DefaultActive(bestPos);
+  pps.setTransquantBypassEnabledFlag(getTransquantBypassEnabledFlag());
+  pps.setUseTransformSkip( m_useTransformSkip );
+  pps.getPpsRangeExtension().setLog2MaxTransformSkipBlockSize( m_log2MaxTransformSkipBlockSize  );
 
   if (m_sliceSegmentMode != NO_SLICES)
   {
-    m_cPPS.setDependentSliceSegmentsEnabledFlag( true );
-  }
+    pps.setDependentSliceSegmentsEnabledFlag( true );
+  }
+
+  xInitPPSforTiles(pps);
 }
 
 //Function for initializing m_RPSList, a list of TComReferencePictureSet, based on the GOPEntry objects read from the config file.
-Void TEncTop::xInitRPS(Bool isFieldCoding)
+Void TEncTop::xInitRPS(TComSPS &sps, Bool isFieldCoding)
 {
   TComReferencePictureSet*      rps;
 
-  m_cSPS.createRPSList(getGOPSize() + m_extraRPSs + 1);
-  TComRPSList* rpsList = m_cSPS.getRPSList();
+  sps.createRPSList(getGOPSize() + m_extraRPSs + 1);
+  TComRPSList* rpsList = sps.getRPSList();
 
   for( Int i = 0; i < getGOPSize()+m_extraRPSs; i++)
   {
-    GOPEntry ge = getGOPEntry(i);
+    const GOPEntry &ge = getGOPEntry(i);
     rps = rpsList->getReferencePictureSet(i);
     rps->setNumberOfPictures(ge.m_numRefPics);
@@ -1480,15 +1608,18 @@
 }
 
-Void  TEncTop::xInitPPSforTiles()
-{
-  m_cPPS.setTileUniformSpacingFlag( m_tileUniformSpacingFlag );
-  m_cPPS.setNumTileColumnsMinus1( m_iNumColumnsMinus1 );
-  m_cPPS.setNumTileRowsMinus1( m_iNumRowsMinus1 );
+Void  TEncTop::xInitPPSforTiles(TComPPS &pps) 
+#if NH_MV
+  const
+#endif
+{
+  pps.setTileUniformSpacingFlag( m_tileUniformSpacingFlag );
+  pps.setNumTileColumnsMinus1( m_iNumColumnsMinus1 );
+  pps.setNumTileRowsMinus1( m_iNumRowsMinus1 );
   if( !m_tileUniformSpacingFlag )
   {
-    m_cPPS.setTileColumnWidth( m_tileColumnWidth );
-    m_cPPS.setTileRowHeight( m_tileRowHeight );
-  }
-  m_cPPS.setLoopFilterAcrossTilesEnabledFlag( m_loopFilterAcrossTilesEnabledFlag );
+    pps.setTileColumnWidth( m_tileColumnWidth );
+    pps.setTileRowHeight( m_tileRowHeight );
+  }
+  pps.setLoopFilterAcrossTilesEnabledFlag( m_loopFilterAcrossTilesEnabledFlag );
 
   // # substreams is "per tile" when tiles are independent.
@@ -1557,4 +1688,101 @@
 }
 
+#if JCTVC_Y0038_PARAMS
+#if NH_MV
+Void TEncTop::setParamSetChanged(Int id, Bool isPps )
+{
+  if ( isPps )
+  {
+    m_ppsMap.setChangedFlag(id);
+  }
+  else
+  {
+    m_spsMap.setChangedFlag(id);
+  }
+}
+#else
+
+Void TEncTop::setParamSetChanged(Int spsId, Int ppsId)
+{
+  m_ppsMap.setChangedFlag(ppsId);
+  m_spsMap.setChangedFlag(spsId);
+}
+#endif
+#endif
+
+Bool TEncTop::PPSNeedsWriting(Int ppsId)
+{
+  Bool bChanged=m_ppsMap.getChangedFlag(ppsId);
+  m_ppsMap.clearChangedFlag(ppsId);
+  return bChanged;
+}
+
+Bool TEncTop::SPSNeedsWriting(Int spsId)
+{
+  Bool bChanged=m_spsMap.getChangedFlag(spsId);
+  m_spsMap.clearChangedFlag(spsId);
+  return bChanged;
+}
+
+#if X0038_LAMBDA_FROM_QP_CAPABILITY
+Int TEncCfg::getQPForPicture(const UInt gopIndex, const TComSlice *pSlice) const
+{
+  const Int lumaQpBDOffset = pSlice->getSPS()->getQpBDOffset(CHANNEL_TYPE_LUMA);
+  Int qp;
+
+  if (getCostMode()==COST_LOSSLESS_CODING)
+  {
+    qp=LOSSLESS_AND_MIXED_LOSSLESS_RD_COST_TEST_QP;
+  }
+  else
+  {
+    const SliceType sliceType=pSlice->getSliceType();
+
+    qp = getBaseQP();
+
+#if JVET_G0101_QP_SWITCHING
+    // modify QP if a fractional QP was originally specified, cause dQPs to be 0 or 1.
+    const Int* pdQPs = getdQPs();
+    if ( pdQPs )
+    {
+      qp += pdQPs[ pSlice->getPOC() ];
+    }
+#endif
+
+    if(sliceType==I_SLICE)
+    {
+      qp += getIntraQPOffset();
+    }
+    else
+    {
+      // Only adjust QP when not lossless
+      if (!(( getMaxDeltaQP() == 0 ) && (!getLumaLevelToDeltaQPMapping().isEnabled()) && (qp == -lumaQpBDOffset ) && (pSlice->getPPS()->getTransquantBypassEnabledFlag())))
+      {
+        const GOPEntry &gopEntry=getGOPEntry(gopIndex);
+        // adjust QP according to the QP offset for the GOP entry.
+        qp +=gopEntry.m_QPOffset;
+
+        // adjust QP according to QPOffsetModel for the GOP entry.
+        Double dqpOffset=qp*gopEntry.m_QPOffsetModelScale+gopEntry.m_QPOffsetModelOffset+0.5;
+        Int qpOffset = (Int)floor(Clip3<Double>(0.0, 3.0, dqpOffset));
+        qp += qpOffset ;
+      }
+    }
+
+#if !JVET_G0101_QP_SWITCHING
+    // modify QP if a fractional QP was originally specified, cause dQPs to be 0 or 1.
+    const Int* pdQPs = getdQPs();
+    if ( pdQPs )
+    {
+      qp += pdQPs[ pSlice->getPOC() ];
+    }
+#endif
+  }
+  qp = Clip3( -lumaQpBDOffset, MAX_QP, qp );
+  return qp;
+}
+#endif
+
+
 #if NH_MV
 Int TEncTop::getFrameId(Int iGOPid)  
@@ -1583,4 +1811,11 @@
   }
   return pcPic;
+}
+
+
+Int TEncTop::xGetPsIdAndPsLayerId( )
+{
+  // LayerId of the parameter set and the Parameter set id are always equal in HTM
+  return ( m_sendParameterSets ?  ( getLayerId() == 0 ?  0 : 1 )  : getLayerId() );
 }
 
@@ -1700,5 +1935,8 @@
   }
 }
-#endif
+
+
+#endif
+
 
 //! \}
Index: /trunk/source/Lib/TLibEncoder/TEncTop.h
===================================================================
--- /trunk/source/Lib/TLibEncoder/TEncTop.h	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/TEncTop.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -83,5 +83,5 @@
   TComPicLists*           m_ivPicLists;                   ///< access to picture lists of other layers 
 #endif
-#if NH_3D_IC
+#if NH_3D
   Int *m_aICEnableCandidate;
   Int *m_aICEnableNum;
@@ -104,7 +104,17 @@
   TEncSlice               m_cSliceEncoder;                ///< slice encoder
   TEncCu                  m_cCuEncoder;                   ///< CU encoder
+
+#if NH_3D  
+  TComSps3dExtension     m_sps3dExtension;
+#endif
+
   // SPS
-  TComSPS                 m_cSPS;                         ///< SPS. This is the base value. This is copied to TComPicSym
-  TComPPS                 m_cPPS;                         ///< PPS. This is the base value. This is copied to TComPicSym
+#if NH_MV
+  ParameterSetMap<TComSPS>& m_spsMap;                      ///< SPS. This is the base value. This is copied to TComPicSym
+  ParameterSetMap<TComPPS>& m_ppsMap;                      ///< PPS. This is the base value. This is copied to TComPicSym
+#else
+  ParameterSetMap<TComSPS> m_spsMap;                      ///< SPS. This is the base value. This is copied to TComPicSym
+  ParameterSetMap<TComPPS> m_ppsMap;                      ///< PPS. This is the base value. This is copied to TComPicSym
+#endif
   // RD cost computation
   TComRdCost              m_cRdCost;                      ///< RD cost computation class
@@ -135,17 +145,28 @@
   TEncAnalyze             m_cAnalyzeAll_in;
 #endif
+  
 protected:
-  Void  xGetNewPicBuffer  ( TComPic*& rpcPic );           ///< get picture buffer which will be processed
-  Void  xInitVPS          ();                             ///< initialize VPS from encoder options
-  Void  xInitSPS          ();                             ///< initialize SPS from encoder options
-  Void  xInitPPS          ();                             ///< initialize PPS from encoder options
-  Void  xInitScalingLists();                              ///< initialize scaling lists
-  Void  xInitHrdParameters();                             ///< initialize HRD parameters
-
-  Void  xInitPPSforTiles  ();
-  Void  xInitRPS          (Bool isFieldCoding);           ///< initialize PPS from encoder options
+  Void  xGetNewPicBuffer  ( TComPic*& rpcPic, Int ppsId ); ///< get picture buffer which will be processed. If ppsId<0, then the ppsMap will be queried for the first match.
+  Void  xInitVPS          (TComVPS &vps, const TComSPS &sps); ///< initialize VPS from encoder options
+  Void  xInitSPS          (TComSPS &sps);                 ///< initialize SPS from encoder options
+  Void  xInitPPS          (TComPPS &pps, const TComSPS &sps) const; ///< initialize PPS from encoder options
+  Void  xInitScalingLists (TComSPS &sps, TComPPS &pps);   ///< initialize scaling lists
+  Void  xInitHrdParameters(TComSPS &sps);                 ///< initialize HRD parameters
+
+#if NH_MV  
+  Int   xGetPsIdAndPsLayerId      ( ); 
+
+  Void  xInitPPSforTiles  (TComPPS &pps) const ;
+#else
+  Void  xInitPPSforTiles  (TComPPS &pps);
+#endif
+  Void  xInitRPS          (TComSPS &sps, Bool isFieldCoding);           ///< initialize PPS from encoder options
 
 public:
+#if NH_MV
+  TEncTop( ParameterSetMap<TComSPS>& spsMap, ParameterSetMap<TComPPS>& ppsMap );
+#else
   TEncTop();
+#endif
   virtual ~TEncTop();
 
@@ -160,5 +181,5 @@
   TComPicLists* getIvPicLists() { return m_ivPicLists; }
 #endif
-#if NH_3D_IC
+#if NH_3D
   Int*      getICEnableCandidate() { return m_aICEnableCandidate; }
   Int*      getICEnableNum() { return m_aICEnableNum; }
@@ -212,10 +233,19 @@
 #endif
 #if NH_3D
-  Void                    setSps3dExtension     ( TComSps3dExtension sps3dExtension ) { m_cSPS.setSps3dExtension( sps3dExtension );  };
-#endif
-#if NH_3D_IC
+  Void                    setSps3dExtension     ( TComSps3dExtension sps3dExtension ) { m_sps3dExtension = sps3dExtension;  };
   Void                    setICEnableCandidate         ( Int* ICEnableCandidate) { m_aICEnableCandidate = ICEnableCandidate; }
   Void                    setICEnableNum         ( Int* ICEnableNum) { m_aICEnableNum = ICEnableNum; }
 #endif
+
+#if JCTVC_Y0038_PARAMS
+#if NH_MV
+  Void                   setParamSetChanged(Int iD, Bool isPps );
+#else
+  Void                   setParamSetChanged(Int spsId, Int ppsId);
+#endif
+#endif
+  Bool                   PPSNeedsWriting(Int ppsId);
+  Bool                   SPSNeedsWriting(Int spsId);
+
   // -------------------------------------------------------------------------------------------------------------------
   // encoder function
@@ -248,5 +278,9 @@
                std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded, Bool isTff);
 #endif
-  Void printSummary(Bool isField) { m_cGOPEncoder.printOutSummary (m_uiNumAllPicCoded, isField, m_printMSEBasedSequencePSNR, m_printSequenceMSE, m_cSPS.getBitDepths()); }
+#if JVET_F0064_MSSSIM
+  Void printSummary(Bool isField) { m_cGOPEncoder.printOutSummary (m_uiNumAllPicCoded, isField, m_printMSEBasedSequencePSNR, m_printSequenceMSE, m_printMSSSIM, m_spsMap.getFirstPS()->getBitDepths()); }
+#else
+  Void printSummary(Bool isField) { m_cGOPEncoder.printOutSummary (m_uiNumAllPicCoded, isField, m_printMSEBasedSequencePSNR, m_printSequenceMSE, m_spsMap.getFirstPS()->getBitDepths()); }
+#endif
 
 #if NH_3D_VSO
Index: /trunk/source/Lib/TLibEncoder/WeightPredAnalysis.cpp
===================================================================
--- /trunk/source/Lib/TLibEncoder/WeightPredAnalysis.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/WeightPredAnalysis.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibEncoder/WeightPredAnalysis.h
===================================================================
--- /trunk/source/Lib/TLibEncoder/WeightPredAnalysis.h	(revision 1412)
+++ /trunk/source/Lib/TLibEncoder/WeightPredAnalysis.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibExtractor/TExtrTop.cpp
===================================================================
--- /trunk/source/Lib/TLibExtractor/TExtrTop.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibExtractor/TExtrTop.cpp	(revision 1413)
@@ -48,5 +48,5 @@
 Void TExtrTop::init()
 {
-  m_cEntropyDecoder.init(&m_cPrediction);
+  m_cEntropyDecoder.init(&m_cPrediction, NULL);
 
   m_acSPSBuffer.clear();
Index: /trunk/source/Lib/TLibRenderer/TRenModel.cpp
===================================================================
--- /trunk/source/Lib/TLibRenderer/TRenModel.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibRenderer/TRenModel.cpp	(revision 1413)
@@ -418,17 +418,8 @@
 
 #if H_3D_VSO_EARLY_SKIP
-#if RM_INIT_FIX
   m_apcRenModels[iModelNum]->create( iMode ,m_iWidth, m_iHeight, m_iShiftPrec, m_aaaiSubPelShiftLut, m_iHoleMargin,  bUseOrgRef, ( iMode != 2 )  ? BLEND_NONE : iBlendMode , m_bLimOutput, m_bEarlySkip );
+
 #else
-  m_apcRenModels[iModelNum]->create( iMode ,m_iWidth, m_iHeight, m_iShiftPrec, m_aaaiSubPelShiftLut, m_iHoleMargin,  bUseOrgRef, iBlendMode, m_bLimOutput, m_bEarlySkip );
-#endif
-
-#else
-
-#if RM_INIT_FIX
   m_apcRenModels[iModelNum]->create( iMode ,m_iWidth, m_iHeight, m_iShiftPrec, m_aaaiSubPelShiftLut, m_iHoleMargin,  bUseOrgRef, ( iMode != 2 )  ? BLEND_NONE : iBlendMode, m_bLimOutput );
-#else
-  m_apcRenModels[iModelNum]->create( iMode ,m_iWidth, m_iHeight, m_iShiftPrec, m_aaaiSubPelShiftLut, m_iHoleMargin,  bUseOrgRef, iBlendMode, m_bLimOutput );
-#endif
 #endif
 
@@ -507,26 +498,4 @@
 
   // Render
-#if !RM_FIX_SETUP
-  m_apcRenModels[iModelNum]->setupLutAndRef(  pcPicYuvRefView, ppiShiftLutLeft, ppiBaseShiftLutLeft, ppiShiftLutRight, ppiBaseShiftLutRight, iDistToLeft, bAnyRefFromOrg );
-
-  // Setup with actual data  
-    for (Int iBaseViewIdx = 0; iBaseViewIdx < m_iNumOfBaseViews; iBaseViewIdx++ )
-    {
-      if ( m_aaeBaseViewPosInModel[iBaseViewIdx][iModelNum] != VIEWPOS_INVALID )
-      {
-        m_apcRenModels[iModelNum]->setLRView(
-          m_aaeBaseViewPosInModel[iBaseViewIdx][iModelNum],
-          m_aapiCurVideoPel      [iBaseViewIdx],
-          m_aaiCurVideoStrides   [iBaseViewIdx],
-          m_apiCurDepthPel       [iBaseViewIdx],
-          m_aiCurDepthStrides    [iBaseViewIdx]
-        );
-      }
-    }
-  // Render initial state
-  AOT( m_bLimOutput && m_aaeBaseViewPosInModel[ iEncViewSIdx ][iModelNum] == VIEWPOS_INVALID );
-  m_apcRenModels[iModelNum]->setupInitialState( m_bLimOutput ? m_aaeBaseViewPosInModel[ iEncViewSIdx ][iModelNum] : VIEWPOS_INVALID );  
-
-#else
   m_apcRenModels[iModelNum]->setupLut(  ppiShiftLutLeft, ppiBaseShiftLutLeft, ppiShiftLutRight, ppiBaseShiftLutRight, iDistToLeft );
   
@@ -587,5 +556,4 @@
     m_apcRenModels[iModelNum]->setLimOutStruct( (curViewPosInModel == VIEWPOS_RIGHT)  ? VIEWPOS_LEFT : VIEWPOS_RIGHT );
   }  
-#endif
 }
 
Index: /trunk/source/Lib/TLibRenderer/TRenSingleModel.cpp
===================================================================
--- /trunk/source/Lib/TLibRenderer/TRenSingleModel.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibRenderer/TRenSingleModel.cpp	(revision 1413)
@@ -246,19 +246,4 @@
 
 
-#if !RM_FIX_SETUP
-template <BlenMod iBM, Bool bBitInc> Void
-  TRenSingleModelC<iBM,bBitInc>::setupInitialState( Int curViewPosInModel )
-{
-  xRenderAll( );
-
-  if ( m_bLimOutput )
-  {
-    AOT( curViewPosInModel == VIEWPOS_INVALID )
-    xSetLimOutStruct( (curViewPosInModel == VIEWPOS_RIGHT)  ? VIEWPOS_LEFT : VIEWPOS_RIGHT );
-  }
-}
-#endif
-
-#if RM_FIX_SETUP
 template <BlenMod iBM, Bool bBitInc> Void
   TRenSingleModelC<iBM,bBitInc>::setupRefView      ( TComPicYuv* pcOrgVideo )
@@ -287,12 +272,5 @@
 template <BlenMod iBM, Bool bBitInc> Void
   TRenSingleModelC<iBM,bBitInc>::setupLut( Int** ppiShiftLutLeft, Int** ppiBaseShiftLutLeft, Int** ppiShiftLutRight,  Int** ppiBaseShiftLutRight,  Int iDistToLeft )
-#else
-template <BlenMod iBM, Bool bBitInc> Void
-  TRenSingleModelC<iBM,bBitInc>::setupLutAndRef( TComPicYuv* pcOrgVideo, Int** ppiShiftLutLeft, Int** ppiBaseShiftLutLeft, Int** ppiShiftLutRight,  Int** ppiBaseShiftLutRight,  Int iDistToLeft, Bool bRenderRef )
-#endif
-{
-#if !RM_FIX_SETUP
-  AOT( !m_bUseOrgRef && pcOrgVideo );
-#endif
+{
   AOT( (ppiShiftLutLeft  == NULL) && (m_iMode == 0 || m_iMode == 2) );
   AOT( (ppiShiftLutRight == NULL) && (m_iMode == 1 || m_iMode == 2) );
@@ -306,42 +284,11 @@
     TRenFilter<REN_BIT_DEPTH>::setupZLUT( true, 30, iDistToLeft, ppiBaseShiftLutLeft, ppiBaseShiftLutRight, m_iBlendZThres, m_iBlendDistWeight, m_piInvZLUTLeft, m_piInvZLUTRight );
   }
-
-#if !RM_FIX_SETUP
-  // Copy Reference
-  m_pcPicYuvRef = pcOrgVideo;
-
-  if ( pcOrgVideo )
-  {
-    assert( pcOrgVideo->getChromaFormat() == CHROMA_420 );     
-
-    TRenFilter<REN_BIT_DEPTH>::copy(             pcOrgVideo->getAddr( COMPONENT_Y  ) +  m_iHorOffset       * pcOrgVideo->getStride( COMPONENT_Y  ), pcOrgVideo->getStride( COMPONENT_Y  ), m_iWidth,      m_iUsedHeight,      m_aapiRefVideoPel[0], m_aiRefVideoStrides[0]);
-    TRenFilter<REN_BIT_DEPTH>::sampleCUpHorUp(0, pcOrgVideo->getAddr( COMPONENT_Cb ) + (m_iHorOffset >> 1) * pcOrgVideo->getStride( COMPONENT_Cb ), pcOrgVideo->getStride( COMPONENT_Cb ), m_iWidth >> 1, m_iUsedHeight >> 1, m_aapiRefVideoPel[1], m_aiRefVideoStrides[1]);
-    TRenFilter<REN_BIT_DEPTH>::sampleCUpHorUp(0, pcOrgVideo->getAddr( COMPONENT_Cr ) + (m_iHorOffset >> 1) * pcOrgVideo->getStride( COMPONENT_Cr ), pcOrgVideo->getStride( COMPONENT_Cr ), m_iWidth >> 1, m_iUsedHeight >> 1, m_aapiRefVideoPel[2], m_aiRefVideoStrides[2]);    
-    xSetStructRefView();
-  }
-  else
-  {
-    if ( bRenderRef )
-    {    
-      xRenderAll( ); 
-      xSetStructSynthViewAsRefView();
-    }
-  }
-#endif
-}
-
-template <BlenMod iBM, Bool bBitInc> Void
-#if RM_FIX_SETUP
+}
+
+template <BlenMod iBM, Bool bBitInc> Void
 TRenSingleModelC<iBM,bBitInc>::renderAll( )
-#else
-TRenSingleModelC<iBM,bBitInc>::xRenderAll( )
-#endif
 {
   // Initial Rendering
-#if RM_FIX_SETUP
   resetStructError();
-#else
-  xResetStructError();
-#endif
   xInitSampleStructs();
   switch ( m_iMode )
@@ -465,9 +412,5 @@
 
 template <BlenMod iBM, Bool bBitInc> Void
-#if RM_FIX_SETUP
 TRenSingleModelC<iBM,bBitInc>::resetStructError( )
-#else
-TRenSingleModelC<iBM,bBitInc>::xResetStructError( )
-#endif
 {
   RenModelOutPels* pcCurOutSampleRow = m_pcOutputSamples;
@@ -484,9 +427,5 @@
 
 template <BlenMod iBM, Bool bBitInc> Void
-#if RM_FIX_SETUP
   TRenSingleModelC<iBM,bBitInc>::setLimOutStruct(Int iSourceViewPos )
-#else
-  TRenSingleModelC<iBM,bBitInc>::xSetLimOutStruct(Int iSourceViewPos )
-#endif
 {  
   RM_AOF( m_bLimOutput ); 
@@ -537,9 +476,5 @@
 
 template <BlenMod iBM, Bool bBitInc> Void
-#if RM_FIX_SETUP
 TRenSingleModelC<iBM,bBitInc>::setStructSynthViewAsRefView( )
-#else
-TRenSingleModelC<iBM,bBitInc>::xSetStructSynthViewAsRefView( )
-#endif
 {
   AOT( m_iMode < 0 || m_iMode > 2);
Index: /trunk/source/Lib/TLibRenderer/TRenSingleModel.h
===================================================================
--- /trunk/source/Lib/TLibRenderer/TRenSingleModel.h	(revision 1412)
+++ /trunk/source/Lib/TLibRenderer/TRenSingleModel.h	(revision 1413)
@@ -78,5 +78,5 @@
   virtual Void   setLRView         ( Int iViewPos, Pel** apiCurVideoPel, Int* aiCurVideoStride, Pel* piCurDepthPel, Int iCurDepthStride ) = 0;
   virtual Void   setupPart         ( UInt uiHorOffset,       Int iUsedHeight ) = 0;
-#if RM_FIX_SETUP
+
   virtual Void   setupLut          ( Int** ppiShiftLutLeft, Int** ppiBaseShiftLutLeft, Int** ppiShiftLutRight, Int** ppiBaseShiftLutRight, Int iDistToLeft ) = 0;
   virtual Void   setupRefView      ( TComPicYuv* pcOrgVideo ) = 0;
@@ -86,8 +86,4 @@
   virtual Void   resetStructError            ()                     = 0;
   virtual Void   setLimOutStruct             ( Int iSourceViewPos ) = 0; 
-#else
-  virtual Void   setupLutAndRef    ( TComPicYuv* pcOrgVideo, Int** ppiShiftLutLeft, Int** ppiBaseShiftLutLeft, Int** ppiShiftLutRight, Int** ppiBaseShiftLutRight, Int iDistToLeft, Bool bRenderRef ) = 0;
-  virtual Void   setupInitialState ( Int curViewPosInModel ) = 0;
-#endif
 
   // Set Data
@@ -195,5 +191,5 @@
   Void   setLRView         ( Int iViewPos, Pel** apiCurVideoPel, Int* aiCurVideoStride, Pel* piCurDepthPel, Int iCurDepthStride );  
   Void   setupPart         ( UInt uiHorOffset,       Int uiUsedHeight ); 
-#if RM_FIX_SETUP
+
   Void   setupLut          (  Int** ppiShiftLutLeft, Int** ppiBaseShiftLutLeft, Int** ppiShiftLutRight, Int** ppiBaseShiftLutRight, Int iDistToLeft);
   Void   setupRefView      ( TComPicYuv* pcOrgVideo );
@@ -203,8 +199,4 @@
   Void              resetStructError            ();
   Void              setLimOutStruct             ( Int iSourceViewPos ); 
-#else
-  Void   setupLutAndRef    ( TComPicYuv* pcOrgVideo, Int** ppiShiftLutLeft, Int** ppiBaseShiftLutLeft, Int** ppiShiftLutRight, Int** ppiBaseShiftLutRight, Int iDistToLeft, Bool bRenderRef );
-  Void   setupInitialState ( Int curViewPosInModel );
-#endif
 
 
@@ -229,8 +221,4 @@
 
 private:
-
-#if !RM_FIX_SETUP
-   __inline Void  xRenderAll( );
-#endif
 
 
@@ -310,13 +298,5 @@
        
   Void            xSetStructRefView            ();
-#if !RM_FIX_SETUP
-  Void            xResetStructError            ();
-  Void            xSetLimOutStruct             (Int iSourceViewPos ); 
-#endif
-  
   Void            xInitSampleStructs           ();
-#if !RM_FIX_SETUP
-  Void            xSetStructSynthViewAsRefView ();
-#endif
   Void            xCopy2PicYuv                ( Pel** ppiSrcVideoPel, Int* piStrides, TComPicYuv* rpcPicYuvTarget );
 
Index: /trunk/source/Lib/TLibVideoIO/TVideoIOYuv.cpp
===================================================================
--- /trunk/source/Lib/TLibVideoIO/TVideoIOYuv.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibVideoIO/TVideoIOYuv.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -186,7 +186,7 @@
  * seekable, by consuming bytes.
  */
-Void TVideoIOYuv::skipFrames(UInt numFrames, UInt width, UInt height, ChromaFormat format)
-{
-  if (!numFrames)
+Void TVideoIOYuv::skipFrames(Int numFrames, UInt width, UInt height, ChromaFormat format)
+{
+  if (numFrames==0)
   {
     return;
@@ -733,5 +733,8 @@
   }
 
+  if(pPicYuvUser)
+  {
   ColourSpaceConvert(*pPicYuvTrueOrg, *pPicYuvUser, ipcsc, true);
+  }
 
   return true;
Index: /trunk/source/Lib/TLibVideoIO/TVideoIOYuv.h
===================================================================
--- /trunk/source/Lib/TLibVideoIO/TVideoIOYuv.h	(revision 1412)
+++ /trunk/source/Lib/TLibVideoIO/TVideoIOYuv.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -67,5 +67,5 @@
   Void  close ();                                           ///< close file
 
-  Void skipFrames(UInt numFrames, UInt width, UInt height, ChromaFormat format);
+  Void skipFrames(Int numFrames, UInt width, UInt height, ChromaFormat format);
 
   // if fileFormat<NUM_CHROMA_FORMAT, the format of the file is that format specified, else it is the format of the TComPicYuv.
Index: /trunk/source/Lib/libmd5/MD5.h
===================================================================
--- /trunk/source/Lib/libmd5/MD5.h	(revision 1412)
+++ /trunk/source/Lib/libmd5/MD5.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/libmd5/libmd5.h
===================================================================
--- /trunk/source/Lib/libmd5/libmd5.h	(revision 1412)
+++ /trunk/source/Lib/libmd5/libmd5.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
